# -*- coding: utf-8 -*-

""" SOER figures metadata exported from Excel
"""

soer_data = {
  "rows" : [
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP100_Fig2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Indexed trends in air quality''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution''',
      "Figure type" : '''Graph''',
      "Description" : '''Indexed trend in annual mean urban air quality over the period 1997-2008 9reference year 1997). All urban and suburban background stations operational (that is at least reporting over 9 years with a yearly coverage of at least 274 days) during the period 1997-2008 are included. A general, Europe-wide averaged picture is shown, with a bias towards regions with high station density.''',
      "Themes" : '''Air pollution, Environment and health''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010, 1.0.1''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.planbureauvoordeleefomgeving.nl/en/index.html, PBL Netherlands Environmental Assessment Agency''',
      "Processor" : '''''',
      "Temporal coverage" : '''1996-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Anke Lukewille; Anke.Lukewille@eea.europa.eu
Outside contact: Frank de Leeuw; frank.deleeuw@pbl.nl
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''http://air-climate.eionet.europa.eu/databases/airbase/index_html''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/AP100_indexedtrend.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP103_Fig2.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Population-weighted concentrations of PM10 and O3 in urban agglomerations of more than 250 000 inhabitants in EU-27''',
      "Creators" : '''EEA, Peder Gabrielsen''',
      "Contributors" : '''Frank de Leeuw''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, air quality, particulate matter, PM10, ozone, O3''',
      "Figure type" : '''Graph''',
      "Description" : '''Urban air quality is of major concern. The high density of population and of economic activities in urban areas results in increased emissions, ambient concentrations and exposure. The Structural Indicator for urban air quality is presented which comprises two sub-elements describing the annual variations in population weighted health-relevant concentrations of (1) ozone and (2) particulate matter (PM10) in ambient air in urban areas.''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''EU-27''',
      "EEA Management Plan" : '''2010, 1.0.2''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://epp.eurostat.ec.europa.eu/portal/page/portal/agriculture/data/main_tables''',
      "Processor" : '''''',
      "Temporal coverage" : '''1999-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Anke Lukewille; Anke.Lukewille@eea.europa.eu
Outside contact: Julio Cabeca; Julio.Cabeca@ec.europa.eu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Data available from Eurostat’s data service: http://epp.eurostat.ec.europa.eu/tgm/table.do?tab=table&init=1&plugin=1&language=en&pcode=tsien100 (ozone) and http://epp.eurostat.ec.europa.eu/tgm/table.do?tab=table&init=1&plugin=1&language=en&pcode=tsien110 (PM10)''',
      "Additional information" : '''Read more: http://www.eea.europa.eu/themes/air
Eurostat Structural Indicator''',
      "Methodology" : '''See Eurostat’s Quality Profiles for ozone: http://epp.eurostat.ec.europa.eu/portal/page/portal/structural_indicators/documents/en041_-_Air_pollution_-_ozone.pdf and for PM10: http://epp.eurostat.ec.europa.eu/portal/page/portal/structural_indicators/documents/en042_-_Air_pollution_-_particulate_matter.pdf.''',
      "Unit" : '''micro gram /m3'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP105_Map2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Years of life lost (YOLL) in EEA countries due to PM2.5 pollution, 2005''',
      "Creators" : '''ETC/ACC (PBL)''',
      "Contributors" : '''ETC/ACC (PBL, NILU, CHMI)''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, PM2.5, health impact''',
      "Figure type" : '''Map''',
      "Description" : '''Health impact caused by expsore top PM2.5.''',
      "Themes" : '''Air pollution, Environment and health''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010, 1.0.2''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.planbureauvoordeleefomgeving.nl/en/index.html, PBL Netherlands Environmental Assessment Agency''',
      "Processor" : '''''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Anke Lukewille; Anke.Lukewille@eea.europa.eu
Outside contact: Frank de Leeuw; frank.deleeuw@pbl.nl
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''http://www.pbl.nl;
http://air-climate.eionet.europa.eu''',
      "Additional information" : '''''',
      "Methodology" : '''see http://air-climate.eionet.europa.eu/reports/ETCACC_TP_2009_1_European_PM2.5_HIA''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP106_Fig2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Regional average number of exceedances of the EU long-term objective for ozone (120 µg/m3) per station during the summer for stations that reported at least one exceedance''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution''',
      "Figure type" : '''Graph''',
      "Description" : '''Average occurrence of LTO per region observed during the period 1998 -2009 and the summer average maximum daily temperature in selected cities''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''EU-27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.chmi.cz/index.html, Czech Hydrometeorological Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1998-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Anke Lukewille; Anke.Lukewille@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''http://www.chmi.cz''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/AP106_SOR2009_Figure_3.1b.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP112_Fig2.8.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Past and projected emissions of the main air pollutants and primary particulate matter. EEA-32 + Western Balkan countries''',
      "Creators" : '''EEA''',
      "Contributors" : '''EEA,ETC/ACC''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, emissions, projections, outlooks, NECD, trend''',
      "Figure type" : '''Graph''',
      "Description" : '''Past and projected emissions of the main air pollutants CO, NMVOC, NOx, NH3 PM2.5 and SOx''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''Albania, Austria, Belgium, Bosnia and Herzegovina, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Iceland, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Former Yugoslav Republic of Macedonia, Malta, Montenegro, Netherlands, Norway, Poland, Portugal, Romania, Serbia, Slovakia, Slovenia, Spain, Sweden, Switzerland, Turkey, United Kingdom''',
      "EEA Management Plan" : '''2010, 3.1.2''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2020''',
      "Contact person(s) for EEA" : '''Inhouse contact: Martin Adams; Martin.Adams@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''AirBase — The European air quality database, European Environment Agency. www.eea.europa.eu/data-and-maps/data/airbase-the-european-air-quality-database-2 (accessed 26 September 2010).''',
      "Additional information" : '''''',
      "Methodology" : '''Past emissions reported by countries to the UNECE CLRTAP Convention and EEA, and for WB countries from UNECE/EMEP estimates. 2010 projections data reported by EU Member States under the EU’s National Emission Ceiling Directive. 2020 outlooks calculated from the GAINS model (IIASA) on the basis of the PRIMES2010 energy scenario. Outlooks shown include a) a 2020 ‘current policy’ baseline, b) the emission reduction required in 2020 in order that the EU-27 achieve the environmental objectives of the Thematic Strategy on Air Pollution (TSAP) and c) the maximum reduction case (MRR) in 2020.''',
      "Unit" : '''kt'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP113_Fig2.10.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Estimated impact of different factors on the reduction in emissions of NOX and SO2 from public electricity and heat production, EEA-32, 1990–2008''',
      "Creators" : '''ETC/ACC''',
      "Contributors" : '''ETC/ACC''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, SOx, NOx, emissions, decomposition, energy''',
      "Figure type" : '''Graph''',
      "Description" : '''The charts show the estimated contributions of various factors affecting emissions from public electricity and heat production including public thermal, nuclear, hydro and wind plants. The top line represents the hypothetical development of emissions that would have occurred due to increasing public heat and electricity production between 1990 and 2006, if the structure and performance of electricity and heat production had remained unchanged. However, there were a number of changes to sector’s structure that tended to reduce emissions, and the contributions of each of these factors to the emission reduction are shown. The cumulative effect of all these changes was that emissions actually followed the trend shown by the lower bars.''',
      "Themes" : '''Air pollution, Energy''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Iceland, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Malta, Netherlands, Norway, Poland, Portugal, Romania, Slovakia, Slovenia, Spain, Sweden, Switzerland, Turkey, United Kingdom''',
      "EEA Management Plan" : '''2009, 2.8.1''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Cinzia Pasterello; Cinzia.Pastorello@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA, ‘EEA aggregated and gap-filled air pollutant emission data’ 2009: http://www.eea.europa.eu/data-and-maps/data/eea-aggregated-and-gap-filled-air-emission-data-3;
Eurostat ‘Energy statistics’ 2009; http://ec.europa.eu/eurostat''',
      "Additional information" : '''''',
      "Methodology" : '''Refer to EEA’s EN09 indicator factsheet specification HYPERLINK "http://www.eea.europa.eu/data-and-maps/indicators/en09-emissions-co2-so2-and-1" http://www.eea.europa.eu/data-and-maps/indicators/en09-emissions-co2-so2-and-1''',
      "Unit" : '''kt'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/AP113_explanatory_factors_SO2_NOx1990-2008.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP120_Fig2.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Sources of selected air pollutants in 2008 for EEA-32 and Western Balkan countries''',
      "Creators" : '''EEA''',
      "Contributors" : '''EEA,ETC/ACC''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, emissions, sectors, sources''',
      "Figure type" : '''Graph''',
      "Description" : '''Sources of selected air pollutants in EEA-32 and West Balkan countries, 2008.''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''Albania, Austria, Belgium, Bosnia and Herzegovina, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Iceland, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Former Yugoslav Republic of Macedonia, Malta, Montenegro, Netherlands, Norway, Poland, Portugal, Romania, Serbia, Slovakia, Slovenia, Spain, Sweden, Switzerland, Turkey, United Kingdom''',
      "EEA Management Plan" : '''2010, 1.1.1''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Martin Adams; Martin.Adams@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA. Air pollutant emission dataviewer (CLRTAP Convention), 2010; http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=478
UNECE/EMEP. ‘Emissions as used in EMEP Models’, 2010; http://www.ceip.at/emission-data-webdab/emissions-used-in-emep-models''',
      "Additional information" : '''Sector labels not displayed for insignificant emission sources''',
      "Methodology" : '''Emissions reported by countries to the UNECE CLRTAP Convention and EEA, and for WB countries from UNECE/EMEP estimates.''',
      "Unit" : '''kt'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/AP120_pollutant_sector_share.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP121_Map4.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''The modelled effects of introducing road vehicle emissions standards and the LCP/IPPC Directives for large combustion plants on PM2.5 concentrations in Europe in 2005''',
      "Creators" : '''EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, policy, sectors, sources, air quality''',
      "Figure type" : '''Map''',
      "Description" : '''The modelled effects of introducing road vehicle emissions standards (left) and the LCP/IPPC directives for large combustion plants (right) on PM2.5 concentrations in Europe in 2005''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''Albania, Austria, Belgium, Bosnia and Herzegovina, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Iceland, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Former Yugoslav Republic of Macedonia, Malta, Montenegro, Netherlands, Norway, Poland, Portugal, Romania, Serbia, Slovakia, Slovenia, Spain, Sweden, Switzerland, Turkey, United Kingdom''',
      "EEA Management Plan" : '''2010, 1.1.2''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Martin Adams; Martin.Adams@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''ETC/ACC - TNO, 2009; http://air-climate.eionet.europa.eu/''',
      "Additional information" : '''Maps from ‘Effectiveness of European air emission reduction measures’. EEA Technical Report No 8/2010.''',
      "Methodology" : '''Maps use a horizontal resolution of 1/8 x 1/16 degrees (long x lat). The area covered by the maps is -10..40 degrees longitude and 35..70 degrees latitude. The long/lat values given represent the middle of the grid cell''',
      "Unit" : '''micro gram /m3'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP122_Map4.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Difference in O3 impact indicators of human health (SOMO35), and ecosystems (AOT40), in 2005 as a result of the introduction of Euro vehicle emission standards in road transport''',
      "Creators" : '''EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, policy, sectors, sources, air quality''',
      "Figure type" : '''Map''',
      "Description" : '''Difference in O3 impact indicators of human health (SOMO35) (left), and ecosystems (AOT40) (right map), in 2005 as a result of the introduction of Euro vehicle emission standards in road transport''',
      "Themes" : '''Air pollution''',
      "Geographical coverage" : '''Albania, Austria, Belgium, Bosnia and Herzegovina, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Iceland, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Former Yugoslav Republic of Macedonia, Malta, Montenegro, Netherlands, Norway, Poland, Portugal, Romania, Serbia, Slovakia, Slovenia, Spain, Sweden, Switzerland, Turkey, United Kingdom''',
      "EEA Management Plan" : '''2010, 1.1.2''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Martin Adams; Martin.Adams@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''ETC/ACC - TNO, 2009; http://air-climate.eionet.europa.eu/''',
      "Additional information" : '''Maps from ‘Effectiveness of European air emission reduction measures’. EEA Technical Report No 8/2010.''',
      "Methodology" : '''Maps use a horizontal resolution of 1/8 x 1/16 degrees (long x lat). The area covered by the maps is -10..40 degrees longitude and 35..70 degrees latitude. The long/lat values given represent the middle of the grid cell''',
      "Unit" : '''left figure micro gram/m3.days; right figure micro gram/m3.hours;'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/AP123_Fig2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Distance-to-target for the environmental objectives set for the protection of human health, 2008''',
      "Creators" : '''ETC/ACC (PBL)''',
      "Contributors" : '''ETC/ACC (PBL)''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, air pollution, ozone, exceedance, health target value''',
      "Figure type" : '''Graph''',
      "Description" : '''Frequency distribution of the ozone 26th highest maximum daily running 8-hour mean; the target value set in the AQ Directive is 120 ug/m3 (reference period 2008; based on all available operational ozone stations reported to AirBase)''',
      "Themes" : '''Air pollution, Environment and health''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010, 1.0.1''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.planbureauvoordeleefomgeving.nl/en/index.html, PBL Netherlands Environmental Assessment Agency''',
      "Processor" : '''''',
      "Temporal coverage" : '''2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Anke Lukewille; Anke.Lukewille@eea.europa.eu
Outside contact: Frank de Leeuw; frank.deleeuw@pbl.nl
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''AirBase, 2010; http://air-climate.eionet.europa.eu/databases/airbase/index_html''',
      "Additional information" : '''''',
      "Methodology" : '''see http://air-climate.eionet.europa.eu/reports/ETCACC_TP_2010_1_EoI_AQ_meta_info2008''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON104_Fig2.3''',
      "Category" : '''Hard copy''',
      "Title" : '''CO2 emissions caused by consumption in selected EU countries, 2004''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''Dominic Wittmer, Wuppertal Institute''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, CO2 emissions, imports, EU''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure identifies direct and indirect CO2 emissions caused by total national consumption in 2004 in 14 EU countries with available data for carrying out the calculations. CO2 caused by consumption are split into three components: 1) CO2 emitted abroad during the production of imported goods for direct consumption 2) CO2 emitted induced by domestic production for the home market 3) CO2 emitted directly by households through burning of fossil fuels for cooking, heating and in private cars''',
      "Themes" : '''Waste and material resources, household consumption, climate change''',
      "Geographical coverage" : '''Austria, Bulgaria, Czech Republic, Denmark, Germany, France, Greece, Ireland, Italy, Netherlands, Poland, Portugal, Sweden, United Kingdom''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2004''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Department of Global Ecology, Carnegie Institution of Washington, Stanford, CA 94305, 2009
Davis, S. J. and Caldeira, K. (2010) Consumption-based accounting of CO2 emissions. Proceedings of the National Academy of Science of the United states. 8th March 2010.
www.pnas.org/cgi/content/short/0906974107

Eurostat, 2009
Air Emissions Accounts by activity (NACE industries and households) (env_ac_ainacehh)
http://epp.eurostat.ec.europa.eu/portal/page/portal/environmental_accounts/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''The indirect pressures caused by national consumption are derived using Leontief manipulations of a multiregional input output model including 113 regions and 57 sectors based on GTAP version 7.  The methodology can be found in
Davis, S. J. and Caldeira, K. (2010) Consumption-based accounting of CO2 emissions. Proceedings of the National Academy of Science of the United states. 8th March 2010.
The direct pressures from households are obtained from the NAMEA AIR emissions accounts held by Eurostat''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON106_Fig2.4''',
      "Category" : '''Hard copy''',
      "Title" : '''Direct and indirect global pressures caused by private consumption distributed by consumption (COICOP) category in nine EU countries, 2005''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''Dominic Wittmer, Wuppertal Institute''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, direct and indirect pressures, EU''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure identifies the distribution of total global pressures caused by household consumption in 9 EU countries distributed among 12 COICOP consumption categories.
The pressures caused by household consumption categories include both direct and indirect pressures.
Direct pressures are those released during consumption of goods and services i.e. emissions to air from cars and from burning fuels in households for heating, cooking etc. Indirect pressures caused by consumption comprise all pressures released along the production chains of consumed goods. Includes goods produced domestically and imported goods.
4 environmental pressures are included – greenhouse gas emissions; acidification emissions; tropospheric ozone precursors and material consumption.''',
      "Themes" : '''Household consumption, Waste and material resources;''',
      "Geographical coverage" : '''Austria, Czech Republic, Denmark, Germany, France, Italy, Netherlands, Portugal, Sweden''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''José Acosta Fernandez, Wuppertal Institute''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Eurostat, 2009
Air Emissions Accounts by activity (NACE industries and households) (env_ac_ainacehh)
http://epp.eurostat.ec.europa.eu/portal/page/portal/environmental_accounts/data/database

Eurostat, 2009
ESA 95 Supply Use and Input-Output tables
http://epp.eurostat.ec.europa.eu/portal/page/portal/esa95_supply_use_input_tables/data/workbooks''',
      "Additional information" : '''(except material use – Sweden not included)''',
      "Methodology" : '''The indirect pressures caused by household consumption are derived using Leontief manipulations of national accounts matrices including environmental accounts (NAMEA). The methodology used to derive indirect pressures is described in the ETC/SCP 2009 publication ‘Environmental Pressures from European Consumption and Production - A study in integrated environmental and economic analysis, available at http://scp.eionet.europa.eu/publications/working%20paper%20namea2009/wp/working%20paper%20namea2009''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON06_Fig2.4 Direct and indirect pressures caused by private consumption categories.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON107_Fig2.5''',
      "Category" : '''Hard copy''',
      "Title" : '''Relative pressure intensities (unit pressure per Euro of spending) of household consumption categories averaged across 9 EU countries, 2005''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''Dominic Wittmer, Wuppertal Institute''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, environmental pressure intensity, EU''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure compares the environmental pressure intensity of 12 different household consumption categories as defined by COICOP nomenclature i.e. the environmental pressure implications of spending one Euro on a given household consumption category compared to the average Euro spent by households.
The pressures caused by household consumption categories include both direct and indirect pressures.
Direct pressures are those released during consumption of goods and services i.e. emissions to air from cars and from burning fuels in households for heating, cooking etc. Indirect pressures caused by consumption comprise all pressures released along the production chains of consumed goods. Includes goods produced domestically and imported goods.
4 environmental pressure intensities are included – greenhouse gas emissions per Euro; acidification emissions per Euro; tropospheric ozone precursors per Euro and material consumption per Euro.''',
      "Themes" : '''Waste and material resources; climate change''',
      "Geographical coverage" : '''Austria, Czech Republic, Denmark, Germany, France, Italy, Netherlands, Portugal, Sweden''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''José Acosta Fernandez, Wuppertal Institute''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Eurostat, 2009
Air Emissions Accounts by activity (NACE industries and households) (env_ac_ainacehh)
http://epp.eurostat.ec.europa.eu/portal/page/portal/environmental_accounts/data/database

Eurostat, 2009
ESA 95 Supply Use and Input-Output tables
http://epp.eurostat.ec.europa.eu/portal/page/portal/esa95_supply_use_input_tables/data/workbooks''',
      "Additional information" : '''''',
      "Methodology" : '''The indirect pressures caused by household consumption are derived using Leontief manipulations of national accounts matrices including environmental accounts (NAMEA). The methodology used to derive indirect pressures is described in the ETC/SCP 2009 publication ‘Environmental Pressures from European Consumption and Production - A study in integrated environmental and economic analysis’
http://scp.eionet.europa.eu/publications/working%20paper%20namea2009/wp/working%20paper%20namea2009''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON07_Fig 2.5 Relative Pressure intensity of household consumption categories.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON108_Fig2.6''',
      "Category" : '''Hard copy''',
      "Title" : '''Changes in GHG emissions (1995-2005) and material use (2000-2005) caused by national consumption and contributing factors in selected EU countries''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''Dominic Wittmer, Wuppertal Institute''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, decomposition analysis, decoupling, contributing factors, pressures''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure identifies changes in direct and indirect GHG emissions and material use caused by total national consumption in EU countries with available data for carrying out the calculations. The various effects of 3 contributing factors to these trends are shown: real growth in consumption expenditure (i.e. in fixed prices), reductions in the emissions/material use per Euro within individual product chains of final NACE product groups.
Pressures caused by national consumption include both direct and indirect pressures.
Direct pressures are those released during consumption of goods and services i.e. emissions to air from cars and from burning fuels in households for heating, cooking etc. Indirect pressures caused by consumption comprise all pressures released along the production chains of consumed goods. Includes goods produced domestically and imported goods.
2 environmental pressure are included – greenhouse gas emissions and material consumption (based on DMI but including DMI imported in imports).''',
      "Themes" : '''Waste and material resources; household consumption, climate change''',
      "Geographical coverage" : '''Austria, Denmark, Germany, France, Italy, Netherlands, Portugal, Sweden''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''José Acosta Fernandez, Wuppertal Institute''',
      "Temporal coverage" : '''1995, 2000, 2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Eurostat, 2009
Air Emissions Accounts by activity (NACE industries and households) (env_ac_ainacehh)
http://epp.eurostat.ec.europa.eu/portal/page/portal/environmental_accounts/data/database

Eurostat, 2009
ESA 95 Supply Use and Input-Output tables
http://epp.eurostat.ec.europa.eu/portal/page/portal/esa95_supply_use_input_tables/data/workbooks''',
      "Additional information" : '''(Sweden not included for material use)''',
      "Methodology" : '''The indirect pressures caused by national consumption are derived using Leontief manipulations of national accounts matrices including environmental accounts (NAMEA). The methodology used to derive indirect pressures is described in the ETC/SCP 2009 publication ‘Environmental Pressures from European Consumption and Production - A study in integrated environmental and economic analysis’
http://scp.eionet.europa.eu/publications/working%20paper%20namea2009/wp/working%20paper%20namea2009
Decomposition analysis has used methodology described in Rørmose, P and T. Olsen (2005) Structural Decomposition Analysis of Air Emissions in Denmark 1980-2002. Report for Statistics Denmark  http://www.iioa.org/pdf/15th%20Conf/roermose_olsen.pdf''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON08_Fig 2.6 Changes in GHG emissions and material use caused by national consumption.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON109_Fig2.7''',
      "Category" : '''Hard copy''',
      "Title" : '''Key differences between equal income low GHG and high GHG emitting households in Switzerland''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, GHG emissions, low emitting households, high emitting households''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure is showing the variation in green house gas emissions of households with equal income along with variation in contributing factors. Households are grouped in deciles 1-10 (low – high emissions). The 10 % of households with highest GHG emissions (group 10) also has the highest car use, the highest share of single family housing, the most m2 of floor space per person and have the lowest use of green heating (district heating or renewables).''',
      "Themes" : '''household consumption''',
      "Geographical coverage" : '''Switzerland''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2003''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''ETH Zurich, Institute for Environmental Decisions, Natural and Social Science Interface, Universitaetstrasse 22, CHN J72.1, 8092 Zurich, Switzerland, 2009
Original data was presented in journal paper: Girod & de Haan (2009) GHG reduction potential of changes in consumption patterns and higher quality levels from Swiss household consumption survey Energy Policy 37(12): 5650-5661. Bastien Girod sent the background data to ETC/SCP in a personal communication.
http://www.sciencedirect.com/science/journal/03014215''',
      "Additional information" : '''''',
      "Methodology" : '''The empirical basis is the Swiss income and expenditure surveys (2000–2003). These four annual surveys include a total of 14,300 households, which reported all their daily purchases for one month. In addition, information on the available durable goods, household characteristics, dwelling, etc. was collected (BFS, 2003). To assess the total GHG emissions of the households functional units were used for describing household demand.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON09_Fig_2.8_Key differences GHG households.xlsm''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON112_Fig4.2''',
      "Category" : '''Hard copy''',
      "Title" : '''Carbon, material and water footprint for different types of meat, dairy products, vegetables and fruit''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, carbon footprint, material footprint, water footprint''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure compares carbon, material and water footprints for selected foodstuffs (beef, butter, cheese, pork, chicken, greenhouse vegetables, rice, milk, wheat, bread, potatoes and root crop, and apple in season).''',
      "Themes" : '''household consumption, natural resources''',
      "Geographical coverage" : '''Norway, Sweden, Denmark, Germany''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Finish Ministry of the Environment, 2008
Household MIPS - Natural resource consumption of Finnish households and its reduction
http://www.ymparisto.fi/download.asp?contentid=99743&lan=en

Water Footprint Network
Water Footprint Product Gallery
http://www.waterfootprint.org/?page=files/productgallery&product=apple

Danish EPA, 2006
Miljøvurdering af konventionel og økologisk avl af grøntsage - Livscyklusvurdering af produktion i væksthuse og på friland: Tomater, agurker, løg, gulerødder (In Danish)
http://www2.mst.dk/udgiv/Publikationer/2006/87-7614-960-9/pdf/87-7614-961-7.pdf

Report of the Swedish Institute for Food and Biotechnology, 2008
Angervall, T. U. Sonesson, F. Ziegler and C. Christel (2008) Mat och kilmat - En sammanfattning om matens klimatpåverkan i ett livscykelperspektiv (In Swedish).
http://www.teknologiradet.no/Mat_och_klimat2_HrrH1.pdf.file

Öko Institut, 2007
Treibhausgasemissionnen durch Erzeugung und Verabeitung von Lebensmitteln (in German)
http://www.oeko.de/oekodoc/328/2007-011-de.pdf

Århus University, Faculty of Agriculture, 2007
LCA Food Database
http://www.lcafood.dk/

School of Applied Sciences, Cranfield University, UK, 2006
Energy and environmental burdens of organic and non-organic agriculture and horticulture
http://orgprints.org/10160/1/Energy_and_environmental_burdens_of_organic_and_non-organic_agriculture_and_horticulture.pdf

Foodwatch, 2008
Klimawirkungen der Landwirtschaft in Deutschland  (in German)
http://www.foodwatch.de/foodwatch/content/e10/e17197/e17201/e17220/IOEW_Klimawirkungen_der_Landwirtschaft_SR_186_08_ger.pdf''',
      "Additional information" : '''Mostly northern European''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON114_Fig5.1''',
      "Category" : '''Hard copy''',
      "Title" : '''Households’ energy consumption per capita in EEA member countries, 1990 and 2007''',
      "Creators" : '''Almut Reichel, EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, energy consumption, households, electricity consumption''',
      "Figure type" : '''Graph''',
      "Description" : '''The graph shows the average per capita final energy consumption of households in 1990 and 2007, divided into electricity consumption and other energy types''',
      "Themes" : '''household consumption, energy''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990,2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact:
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Eurostat
Final energy consumption of households, nrg_100a-Supply, transformation, consumption - all products - annual data
http://epp.eurostat.ec.europa.eu/portal/page/portal/energy/data/database

Eurostat
Electricity consumption of households (tsdpc310)
http://epp.eurostat.ec.europa.eu/portal/page/portal/energy/data/main_

Eurostat
Total population (tps00001)
http://epp.eurostat.ec.europa.eu/portal/page/portal/population/data/main_tables''',
      "Additional information" : '''Data for Iceland is for 2006 instead of 2007''',
      "Methodology" : '''The data has been calculated from Eurostat data on final energy consumption, electricity consumption of households and population data''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON014_Fig 5.1_Energy consumption households by country.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON115_Fig5.2''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends in heating energy consumption and energy efficiency for housing, EU-27''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, space heating, total energy consumption, energy efficiency''',
      "Figure type" : '''Graph''',
      "Description" : '''Trends in relative and absolute energy consumption for space heating show how increasing per person housing space, and increasing numbers of households are offsetting gains in energy efficiency in buildings in Europe''',
      "Themes" : '''household consumption''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Enerdata, 2009
Unit consumption per dwelling for space heating with climatic corrections
http://services.enerdata.eu

Enerdata, 2009
Unit consumption per m2 for space heating with climatic corrections
http://services.enerdata.eu

Enerdata, 2009
Final consumption of residential for space heating with climatic corrections
http://services.enerdata.eu

Enerdata, 2009
Housing stock
http://services.enerdata.eu

Enerdata, 2009
Average floor area of dwelling
http://services.enerdata.eu''',
      "Additional information" : '''''',
      "Methodology" : '''Methodology for original data not known – contact source organisation - Enerdata''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON15_Fig_5.2_Trends in heating energy consumption and energy efficiency_FINAL.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON116_Fig5.3''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends in energy efficiency and ownership rates of household appliances and electricity consumption in households, EU-27''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, energy efficiency, appliances, white goods, households''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure shows trends in energy efficiency of appliances (dishwasher, TV, washing machine) compared to ownership numbers of these appliances and total electricity consumption for lighting and appliances per dwelling. The figure illustrates that increasing ownership of appliances is more than offsetting gains from energy efficiency improvements in individual appliances.''',
      "Themes" : '''household consumption''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Enerdata, 2009
Stock of dish washers
http://services.enerdata.eu

Enerdata, 2009
Stock of TVs
http://services.enerdata.eu

Enerdata, 2009
Stock of washing machines
http://services.enerdata.eu

Enerdata, 2009
Specific consumption of dish washers
http://services.enerdata.eu

Enerdata, 2009
Specific consumption of TVs
http://services.enerdata.eu

Enerdata, 2009
Specific consumption of washing machines
http://services.enerdata.eu

Enerdata, 2009
Unit consumption per dwelling for lighting and electrical appliances
http://services.enerdata.eu''',
      "Additional information" : '''''',
      "Methodology" : '''Methodology for original data not known – contact source organisation - Enerdata''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON16_Fig_5.3_Trends in appliance energy efficiency and ownership.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON118_Fig5.5''',
      "Category" : '''Hard copy''',
      "Title" : '''Water pricing and household water use in Spain
Water pricing and household water use in Germany''',
      "Creators" : '''Almut Reichel, EEA''',
      "Contributors" : '''Mikael Skou Andersen, EEA
Peter Kristensen, EEA''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, water, prices, household consumption''',
      "Figure type" : '''Graph''',
      "Description" : '''The graph shows the development of average prices for drinking water supply and water consumption of households in Spain.
The graph shows the development of average prices for water supply for human consumption in Estonia.''',
      "Themes" : '''household consumption, water''',
      "Geographical coverage" : '''Spain, Estonia''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2001-2007,1992-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact:
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''National Statistics Institute, Spain, 2003-2010
Encuestas del agua 2001/2002/2003/3004/2005; Encuesta sobre el suministro y tratamiento del agua 2006; Encuesta sobre el suministro y saneamiento del agua . Año 2007/2008
http://www.ine.es/prensa/np607.pdf
http://www.ine.es/prensa/np561.pdf
http://www.ine.es/prensa/np511.pdf
http://www.ine.es/prensa/np470.pdf
http://www.ine.es/prensa/np423.pdf
http://www.ine.es/prensa/np382.pdf
http://www.ine.es/prensa/np335.pdf
http://www.ine.es/prensa/np288.pdf
http://www.ine.es/prensa/np288.pdf

Estonian Environment Information Centre, 2010
Water use in domestic sector, price of water service and income of household member
www.keskkonnainfo.ee''',
      "Additional information" : '''''',
      "Methodology" : '''The data has been taken from press releases on water supply of the Spanish National Statistics Institute. See the sources below for further methodological issues.
The graph shows data produced by the Estonian Environment Information Centre. No information on methodology is available.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON018a_Fig. 5.5a Water price and use in Spain.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON018b_Fig. 5.5b_Water_Price_and consumption_Estonia_UPDATED.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON119_Fig6.1''',
      "Category" : '''Hard copy''',
      "Title" : '''Average annual growth rates for passenger transport, EU-27, 1995-2007''',
      "Creators" : '''Mikkel Stenbæk Hansen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, transport growth rates, passenger-kilometres''',
      "Figure type" : '''Graph''',
      "Description" : '''The Figure is showing average annual growth rates of different means of transport within the EU-27 in the period between 1995-2007. (Actual yearly growth rates are of course differing from the averages used in Fig 6.1.) The values for Air and Sea travel only include domestic and Intra-EU-27 transport. Most numbers are based on estimates and data for Air and Sea are provisional estimates.''',
      "Themes" : '''transport, household consumption''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1995-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: Mikkel Stenbæk Hansen; mshan@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''DG for Energy and Transport, 2009
EU Energy and Transport in Figures
http://ec.europa.eu/energy/publications/statistics/doc/2009_energy_transport_figures.pdf''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON19_Fig 6.1_Average annual growth rates for passenger transport.xlsx''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON120_Fig6.2''',
      "Category" : '''Hard copy''',
      "Title" : '''Indexed consumer prices for passenger transport, EU-27, 1998-2009''',
      "Creators" : '''Mikkel Stenbæk Hansen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, transport prices, price development, consumer prices''',
      "Figure type" : '''Graph''',
      "Description" : '''The Figure shows the development of consumer prices for different modes of passenger transport in EU-27 in the period 1998-2009. The prices are calculated as HICP-values (see methodology section below).''',
      "Themes" : '''Transport, household consumption''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1998-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: Mikkel Stenbæk Hansen; mshan@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Eurostat, 2010
HICP - annual average indices for transport prices
http://epp.eurostat.ec.europa.eu/tgm/table.do?tab=table&init=1&plugin=1&language=en&pcode=tsdtr310''',
      "Additional information" : '''''',
      "Methodology" : '''The numbers, derived from Eurostat and originally HICP-values indexed to the year 2005, were converted to an index with the baseline-year 1998.
The Harmonised Indices of Consumer Prices (HICPs) are a set of European Union Consumer Price Indices calculated according to a harmonised approach and a single set of definitions. The HICP was launched in order to provide a comparable measure of consumer price inflation in the EU. It provides the only official measure of consumer price inflation in the euro-zone for the purposes of monetary policy.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON20_Fig 6.2_Indexed consumer prices for passenger transport.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON122_Fig6.4''',
      "Category" : '''Hard copy''',
      "Title" : '''CO2 emissions from passenger transport (use phase only), EU-27, 2000 and 2005''',
      "Creators" : '''Mikkel Stenbæk Hansen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, CO2-emissions, climate change, greenhouse gas emissions, passenger transport''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure shows total CO2-emissions (attention: not CO2-equivalents; CH4 and N2O were left out due to data-constraints and insignificance as percentage of total emissions) for different means of transports’ usage-phase in the EU-27. Increasing travel resulted in increased direct emissions of CO2 from 2000 to 2005. Modes of transport with high CO2-intensity are private cars and aviation.''',
      "Themes" : '''transport, household consumption''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2000,2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: Mikkel Stenbæk Hansen; mshan@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Lab of Applied Thermodynamics, Thessaloniki, Greece, 2010
PRIMES 2009 Baseline Scenario
http://www.ec4macs.eu''',
      "Additional information" : '''''',
      "Methodology" : '''Data was received from Leonidas Ntyiachristos at the Lab of Applied Thermodynamics, Thessaloniki, Greece, a partner in the European Topic Centre on Air and Climate Change. Data was derived using the PRIMES 2009 Baseline Scenario developed under the EU-LIFE founded “LIFE EC4MACS” (European Consortium for Modelling of Air Pollution and Climate Strategies) project. The dataset delivered to the European Topic Centre on Sustainable Consumption and Production was then converted from tonnes into million tonnes, to be used as data for the diagram.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON123_Fig6.5''',
      "Category" : '''Hard copy''',
      "Title" : '''Growth in private car travel versus fuel efficiency in EU-27''',
      "Creators" : '''David Watson, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, car km travelled, total fuel consumption, fuel efficiency''',
      "Figure type" : '''Graph''',
      "Description" : '''Figure showing total km travelled by car in EU 27, total fuel consumption in EU 27, GDP development, and average fuel consumption per car. Between 1992-2007 savings through more efficient cars are clearly outweighed by a strong increase in km travelled, thus leading to growing overall consumption of fuel in EU 27 only partially decoupled from GDP.''',
      "Themes" : '''household consumption, transport''',
      "Geographical coverage" : '''EU 27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1992-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: David Watson; dawat@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''Enerdata, 2009
Annual distance travelled by cars
http://services.enerdata.eu

Enerdata, 2009
GDP in €2000
http://services.enerdata.eu

Enerdata, 2009
Total consumption of cars
http://services.enerdata.eu

Enerdata, 2009
Average specific consumption (l/100 km) of cars
http://services.enerdata.eu

Enerdata, 2009
Stock of cars
http://services.enerdata.eu''',
      "Additional information" : '''''',
      "Methodology" : '''Methodology for original data not known – contact Enerdata
1) 'Total car km travelled' is calculated by multiplying 'Annual distance travelled by cars' and 'Stock of cars'
2) 'Total CO2 emissions of cars' is calculated by multiplying 'CO2 emissions of cars per km' with  'Total car km travelled'
3) For all dataset included in the graph Index 1992 = 1 is constructed by dividing the values for each year by the value for the year 1992''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON23_Fig 6 5_Growth in private car travel versus fuel efficiency.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON124_Fig6.6''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends and outlooks in transport demand for the different modes of transport, EU-25, 1990-2030''',
      "Creators" : '''Mikkel Stenbæk Hansen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, transport, passenger demand, projections''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure shows past (from 1990) and projected (until 2030) values for passenger transport demand within the EU-25. Results are presented both in absolute numbers (per category values for different means of transport summing up to total annual passenger transport demand in Gpkm for the years 1990-2030) and their respective percentage share of total passenger transport demand in Gpkm.''',
      "Themes" : '''Transport, household consumption''',
      "Geographical coverage" : '''EU 25''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2030''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel and Lars Mortensen; Almut.Reichel@eea.europa.eu and Lars.Mortensen@eea.europa.eu
Outside contact: Mikkel Stenbæk Hansen; mshan@etc.mim.dk
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''European Environmental Agency, 2010
Passenger and freight demand projections for the EU 25
http://www.eea.europa.eu/data-and-maps/figures/passenger-and-freight-demand-projections''',
      "Additional information" : '''''',
      "Methodology" : '''EEA-data on passenger transport demand in Gpkm was used, both in absolute numbers (directly from the EEA-homepage), and converted into percentage values representing the respective share of different means of transport (public road transport, private cars and motorcycles, rail, aviation, inland navigation). The latter was done by dividing category Gpkm values by total transport demand per decennial.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON24_Fig_6.6_Trends and outlooks in passenger transport demand.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CON126_Fig7.2''',
      "Category" : '''Hard copy''',
      "Title" : '''GHG emissions for example holiday trips from Germany, CO2 equivalents per person and day''',
      "Creators" : '''Almut Reichel, EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, consumption, tourism, households''',
      "Figure type" : '''Graph''',
      "Description" : '''The graph shows the GHG emissions associated with different types of example holiday trips from Germany''',
      "Themes" : '''household consumption;tourism''',
      "Geographical coverage" : '''Germany''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-11-26''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact:
Operator: Anne Louise Skov; Anne.skov@eea.europa.eu''',
      "Source" : '''WWF Germany, International Center for Marine Conservation, Hongkongstraße 7, 20457 Hamburg, Germany, 2009
Data has been taken from the report: WWF Germany (2009): The Tourist Climate Footprint. WWF Report on environmental impacts of holiday trips.
www.wwf.de''',
      "Additional information" : '''Year is not specified; published in 2009''',
      "Methodology" : '''The data is taken from the report from WWF Germany (2009): The Tourist Climate Footprint. WWF Report on environmental impacts of holiday trips.''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CON026_Fig 7.2_GHG emissions example holiday trips_UPDATED.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM101_Fig2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Absolute GHG emissions in the EU-27, 1970–2009''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions, Kyoto''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo Fernandez''',
      "Temporal coverage" : '''1970-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories, and EDGAR.''',
      "Unit" : '''Million tonnes of CO2 equivalents'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM101.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM102_Map2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Global greenhouse gas emissions, 2005''',
      "Creators" : '''JRC''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Map''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact: Greet Maenhout; greet.maenhout@jrc.ec.europa.eu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EC-JRC/PBL. EDGAR version 4.0. http://edgar.jrc.ec.europa.eu/, 2009; http://edgar.jrc.ec.europa.eu/background.php''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''EDGAR''',
      "Unit" : '''Gg of CO2 equivalent per grid cell'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM103_Map2.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Global greenhouse gas emissions per capita, 2005''',
      "Creators" : '''JRC''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Map''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact: Greet Maenhout; greet.maenhout@jrc.ec.europa.eu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EC-JRC/PBL. EDGAR version 4.0. http://edgar.jrc.ec.europa.eu/, 2009; http://edgar.jrc.ec.europa.eu/background.php''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''EDGAR''',
      "Unit" : '''Tonne of CO2 equivalent per capita'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM104_Fig2.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends in global greenhouse gas emissions and per capita in Annex I and non-Annex I countries, 1970–2005''',
      "Creators" : '''JRC''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''1970-2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact: Greet Maenhout; greet.maenhout@jrc.ec.europa.eu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EC-JRC/PBL. EDGAR version 4.0. http://edgar.jrc.ec.europa.eu/, 2009; http://edgar.jrc.ec.europa.eu/background.php''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''EDGAR''',
      "Unit" : '''Pg CO2 equivalent and Mg CO2 equivalent per capita'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM105_Fig2.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Global CO2 emissions, 1860–2006''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1860-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, adapted from ‘Air Pollution and Climate Change’: Two sides of the same coin?’''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''CDIAC, EDGAR, IEA and UNFCCC/IPCC guidelines for national GHG inventories''',
      "Unit" : '''Gg of CO2'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM106_Fig2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Change in greenhouse gas emissions by EU Member States, 1990–2008 and share of emissions in 2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Million tonnes of CO2 equivalents; and percentage of total EU-27 greenhouse gas emissions by member state'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM106.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM107_Fig2.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Overview of top decreasing/increasing GHG sources in the EU–27, 1990–2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Million tonnes of CO2 equivalents'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM107.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM108_Fig2.15.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''CO2 emissions from diesel and  gasoline in the EU-27, 1990–2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Gg of CO2'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM108.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM109_Fig2.10.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Change in GHG emissions by main sector in EU-27, 1990–2008 and breakdown by sector, 2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Thousand tonnes of CO2 equivalents; and percentage of total EU-27 greenhouse gas emissions by sector'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM109.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM111_Fig2.8.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Change in GHG emissions by main gas in EU-27, 1990–2008 and breakdown by gas in 2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Million tonnes of CO2 equivalents; and percentage of total EU-27 greenhouse gas emissions by gas'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM111.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM112_Fig2.13.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Mean surface temperature in Europe 1850–2009, annual and by season''',
      "Creators" : '''ETC ACC and Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, climate change impacts''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2009, 2.1.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''ETC ACC and Ricardo Fernandez''',
      "Temporal coverage" : '''1850-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2009, based on CRU HadCRU3 and CRUTEM3 datasets. EEA’s core set indicator ‘Global and European temperature’ http://www.eea.europa.eu/data-and-maps/indicators/global-and-european-temperature/global-and-european-temperature-assessment-2''',
      "Additional information" : '''Europe, defined as the area between 35 o to 70o Northern latitude, -25 o to 30 o Eastern longitude, plus Turkey (=35 o to 40 o North, 30 o to 45 o East).''',
      "Methodology" : '''HadCRU3 and CRUTEM3, Climate Research Unit, University of East Anglia; and KNMI’s Climate explorer''',
      "Unit" : '''Temperature deviation, compared to 1850-1899 average (oC)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM112.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM113_Fig2.14.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Change in heating degree days as fraction of EU-27 mean heating days and change in heating degree days 2004–2009''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change, Energy''',
      "Geographical coverage" : '''EFTA4, EU27, Turkey''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, based on Eurostat’s heating degree days; http://epp.eurostat.ec.europa.eu/portal/page/portal/energy/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''Eurostat''',
      "Unit" : '''Relative heating degree days; and change in heating degree days'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM115_Fig2.11.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Fuel use and CO2 emissions from public electricity and heat production in EU-27''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Terajoules; and Gigagrams of CO2'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM115.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM116_Fig2.12.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Fuel use and CO2 emissions from heating in European households''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''Terajoules; and Gigagrams of CO2'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM116.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM118_Fig2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''World primary energy consumption and CO2 emissions from energy combustion, 1970–2007''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change, Energy''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1970-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''IEA 2009; http://data.iea.org/IEASTORE/DEFAULT.ASP''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''IEA''',
      "Unit" : '''Million tonnes of oil equivalent; and million tonnes of CO2'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM119_Fig2.17.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Gross electricity and primary energy consumption by main fuel in EU-27, 1990–2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change, Energy''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA and Eurostat 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/energy/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''Eurostat’s energy balances''',
      "Unit" : '''GWh; and Ktoe'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM120_Fig2.16.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Change in GDP, population, primary energy and emissions, 1990–2010''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1990-2010''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010, (greenhouse gas emissions); Eurostat (population and energy balances); European Commission Ameco database (GDP); http://epp.eurostat.ec.europa.eu/portal/page/portal/energy/data/database; http://ec.europa.eu/economy_finance/ameco/user/serie/SelectSerie.cfm''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC and IPCC guidelines for national GHG inventories''',
      "Unit" : '''% change year on year; and, index 1990=100'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM122_Fig2.7.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Greenhouse gas emissions per capita and per unit of GDP in purchasing power standards in 2008''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EFTA4, EU27, Turkey''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA, Eurostat 2010; http://dataservice.eea.europa.eu/PivotApp/pivot.aspx?pivotid=475''',
      "Additional information" : '''''',
      "Methodology" : '''UNFCCC / IPCC guidelines for national GHG inventories, Eurostat demographic statistics and Eurostat national accounts''',
      "Unit" : '''greenhouse gas emissions per capita in tonnes per person; and greenhouse gas emissions per GDP as an index where EU-27’s GDP in purchasing power standards=100'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM122.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM123_Fig2.18.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Production and consumption of ozone depleting substances in EEA member countries, 1986–2009''',
      "Creators" : '''Ricardo Fernandez''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EFTA4, EU27, Turkey''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Ricardo.Fernandez@eea.europa.eu''',
      "Temporal coverage" : '''1986-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA, UNEP 2010; http://www.eea.europa.eu/data-and-maps/indicators/#c7=all&c5=&c0=10&b_start=0&c10=CSI''',
      "Additional information" : '''''',
      "Methodology" : '''UNEP data reporting under the Montreal Protocol''',
      "Unit" : '''production and consumption in ODP tonnes'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCM123.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM124_Fig2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Global greenhouse gas  emissions by gas type, 1970–2005''',
      "Creators" : '''JRC''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.1''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Ricardo Fernandez; Ricardo.Fernandez@eea.europa.eu
Outside contact: Greet Maenhout; greet.maenhout@jrc.ec.europa.eu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EC-JRC/PBL. EDGAR version 4.0. http://edgar.jrc.ec.europa.eu/, 2009; http://edgar.jrc.ec.europa.eu/background.php''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''EDGAR''',
      "Unit" : '''Gg of CO2 equivalent per grid cell'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM126_Fig3.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Total GHG emissions in  EU-15 and EU-27 in Mt CO2-equivalent''',
      "Creators" : '''EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''Europe''',
      "EEA Management Plan" : '''2010, 1.3.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''1990-2020''',
      "Contact person(s) for EEA" : '''Inhouse contact: Francois Dejean; Francois.Dejean@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA; http://www.eea.europa.eu/highlights/recession-accelerates-the-decline-in web highlights on 2009 proxy inventory''',
      "Additional information" : '''Recession accelerates the decline in EU greenhouse gas emissions. European Environment Agency, Copenhagen, 2010.''',
      "Methodology" : '''EEA, Greenhouse gas emission trends and projections in Europe''',
      "Unit" : '''Mt of CO2-equivalent'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM127_Fig3.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Total GHG emissions PRIMES/GAINS baseline in EU-27 in Mt CO2-equivalent''',
      "Creators" : '''EEA''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''1990-2020''',
      "Contact person(s) for EEA" : '''Inhouse contact: Francois Dejean; Francois.Dejean@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010''',
      "Additional information" : '''modified from Commission staff working document accompanying the Communication from the Commission to the European Parliament, The Council, The European Economic and Social Committee and The Committee of the Regions. Analysis of options to move beyond 20% greenhouse gas emission reductions and assessing the risks of carbon leakage. Background Information and analysis. Part II. COM(2010) 265 final.''',
      "Methodology" : '''Data from PRIMES/GAINS model submitted to European Commission''',
      "Unit" : '''Mt of CO2-equivalent'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM128_Fig3.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Total GHG emissions, Gt CO2-equivalent''',
      "Creators" : '''PBL''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.planbureauvoordeleefomgeving.nl/en/about_pbl/index.html''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''1990-2020''',
      "Contact person(s) for EEA" : '''Inhouse contact: John van Aardenne; John.Aardenne@eea.europa.eu
Outside contact: Michel den Elzen; michel.denElzen@pbl.nl
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''PBL 2010, http://www.mnp.nl/bibliotheek/rapporten/500114018.pdf''',
      "Additional information" : '''The figure is covering EU and the rest of the world. Netherlands Environmental Assessment Agency (PBL), 2010: Evaluation of the Copenhagen Accord: Chances and risks for the 2o C climate goal. PBL publication number 500114017. May 2010.''',
      "Methodology" : '''''',
      "Unit" : '''Gt of CO2-equivalent'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM129_Fig3.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''World anthropogenic GHG emissions under the WEO baseline scenario''',
      "Creators" : '''John van Aardenne''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.planbureauvoordeleefomgeving.nl/en/index.html, PBL Netherlands Environmental Assessment Agency''',
      "Processor" : '''http://edgar.jrc.ec.europa.eu/index.php, The Emissions Database for Global Atmospheric Research (EDGAR)''',
      "Temporal coverage" : '''2005-2050''',
      "Contact person(s) for EEA" : '''Inhouse contact: John van Aardenne; John.Aardenne@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2009''',
      "Additional information" : '''The figure is covering EU and the rest of the world. Data modified from International Energy Agency World Energy Outlook 2009. OECD/IEA, Paris.''',
      "Methodology" : '''''',
      "Unit" : '''Gt of CO2-equivalent'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCM130_Fig3.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''EU emission profiles compared to a 2° C compatible long-term target''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, mitigation, greenhouse gas emissions''',
      "Figure type" : '''Graph''',
      "Description" : '''Climate change mitigation chapter SOER 2010''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010, 1.3.2''',
      "Last upload" : '''11/22/2010''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2050''',
      "Contact person(s) for EEA" : '''Inhouse contact: John van Aardenne; John.Aardenne@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''European Commission 2009''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : '''%'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW100_Fig1.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Share of imports in EU-27 consumption of selected materials (2000–2007)''',
      "Creators" : '''Helmut Schütz, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, domestic material consumption, Import dependency, Material flows, energy carriers''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows 2000 to 2005 shares of imports of oil, hard coal and natural gas of domestic consumption (DMC) of the EU27''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''2000-2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: helmut.schuetz@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Eurostat, 2009; http://epp.eurostat.ec.europa.eu/portal/page/portal/external_trade/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''The dependence on imports of energy carriers is calculated as percentage of imports of oil, hard coal and natural gas of the domestic consumption (DMC).''',
      "Unit" : '''Percent of imports of DMC (%)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW100_left_side_hsc.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW100_right_side.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW101_Fig1.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends in prices of commodities, 1970–2009''',
      "Creators" : '''Sören Steger, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, development of prices, fossil fuels, metals''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the changes of prices for fossil fuels, selected metals and cement between 1970 and 2009.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''Germany, USA''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''1970-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: soeren.steger@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Statistik der Kohlewirtschaft e.V., 2009; http://www.kohlenstatistik.de/cms/verwaltung/files.php?path=../../download/1275468697_91.0.54.86.xls&name=ENPR.XLS&mime=application/vnd.ms-excel''',
      "Additional information" : '''Germany (Fossil Fuels), USA (Metals + Cement)''',
      "Methodology" : '''The data for prices of fossil fuels, selected metals and cement are taken from the external data bases (fossil fuels: Statistik der Kohlenwirtschaft e.V., metals+cement: USGS)''',
      "Unit" : '''fossil fuels: in Euro/t coal equivalents, metals and cement: in $/t'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW101_Fig2a_14062010.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW103_ID1147_Fig2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Use of resources per person by country, 2000 and 2007 (2005)''',
      "Creators" : '''Sören Steger, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, resource use, DMC per capita''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the DMC per capita for the EU27 countries and selected other countries in 2000 and 2007 or 2005, respectively.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''2000, 2007,2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: soeren.steger@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Eurostat, 2009; http://appsso.eurostat.ec.europa.eu/nui/show.do?dataset=demo_gind&lang=en''',
      "Additional information" : '''''',
      "Methodology" : '''The data are taken from external data bases (DMC from Eurostat and OECD, population from Eurostat Database, and The Conference Board Total Economy Database)''',
      "Unit" : '''tonnes per capita'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW103_Fig4.4_ID1147.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW104_Fig2.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Use of material resources and material productivity EU-15 and EU-12''',
      "Creators" : '''Sören Steger, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, development of GDP, population, DMC, material productivity''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the development of GDP, Population, DMC and Material Productivity for EU15 and EU12 between 1970 (EU15) or 1992 (EU12), respectively, and 2009 or 2007 (DMC, Material productivity), respectively''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU15,EU12''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''1970-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: soeren.steger@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''The Conference Board: The Total Economy Database, Output, Labor and Labor Productivity Country Details, 1950-2009, January 2010 Release; http://www.conference-board.org/data/economydatabase/" http://www.conference-board.org/data/economydatabase/''',
      "Additional information" : '''Temporal coverage:
1970-2009/2007 (EU15), 1992-2009/2007 (EU12)''',
      "Methodology" : '''The data are taken from external data bases (GDP in PPP GK 1990 $US from Total Economy Database, Population from Eurostat, DMC from WI database, IFF database and Eurostat)''',
      "Unit" : '''index1970=100 (EU15) or 1992=100 (EU12)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW104_EU12_and_EU15_Trends_1970_2007.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW105_Fig2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Material productivity by country, 2000 and 2007''',
      "Creators" : '''Sören Steger, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, material productivity''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the material productivity (GDP in 1990 US$ (converted at Geary Khamis PPPs) per tonnes DMC) for the EU27 member states and selected other countries, in 2000 vs 2007 and 2005, respectively.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''2000, 2005, 2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: soeren.steger@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''The Conference Board: The Total Economy Database, Output, Labor and Labor Productivity Country Details, 1950-2009, January 2010 Release; http://www.conference-board.org/data/economydatabase/''',
      "Additional information" : '''Temporal coverage:
2000, 2007 or 2005 respectively''',
      "Methodology" : '''The data are taken from external data bases (GDP data from The Conference Board – Total Economy Database, DMC from Eurostat and OECD).''',
      "Unit" : '''GDP in 1990 US$ (converted at Geary Khamis PPPs) per ton DMC'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW105_GDP_GK1990.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW107_Fig2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Growth in the productivity of labour, energy and materials, EU-15 and EU-12''',
      "Creators" : '''Dominic Wittmer, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, labour productivity, material productivity, energy productivity''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the development of labour productivity, material productivity, and energy productivity in EU15 and EU12.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU27, EU15, EU12''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''1970-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: dominic.wittmer@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''The Conference Board: The Total Economy Database, Output, Labor and Labor Productivity Country Details, 1950-2009, January 2010 Release; http://www.conference-board.org/economics/database.cfm''',
      "Additional information" : '''Temporal coverage
1970/1992-2009''',
      "Methodology" : '''The data are taken from external data bases (GDP in PPP GK 1990 $US, labour hours from EU KLEMS database, DMC from IFF database, WI database, and Eurostat, Total primary energy supply from the Energy Balances of the IEA database).''',
      "Unit" : '''index1970=100 (EU-15), index 1992=100 (EU-12)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW107_Triple Productivities.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW108_Fig2.7.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends in the productivity of labour, energy and materials for selected EU Member States and Turkey''',
      "Creators" : '''Dominic Wittmer, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, labour productivity, material productivity, energy productivity''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the development of labour productivity, material productivity, and energy productivity in selected European countries.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''Austria, Germany, Greece, Spain, Italy, Lithuania, Poland, Turkey''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''1970-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: dominic.wittmer@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''The Conference Board: The Total Economy Database, Output, Labor and Labor Productivity Country Details, 1950-2009, January 2010 Release; http://www.conference-board.org/economics/database.cfm''',
      "Additional information" : '''1970-2009 (for EU15 countries), and 1992-2009 (for other countries)''',
      "Methodology" : '''The data are taken from external data bases (GDP in PPP GK 1990 $US, and labour hours from The Total Economy database, DMC from IFF database, WI database, and Eurostat, Total primary energy supply from the Energy Balances of the IEA database).''',
      "Unit" : '''index1970=100 (for EU15 countries), and index1992=100 (for other countries)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW108_Fig_2.7_300910_for_eps.xlsx''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW111_Fig2.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Changes in physical foreign trade of EU-27, by product group, 1999–2008''',
      "Creators" : '''Helmut Schütz, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, import, export, material flows, trade flows, product groups''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the changes in physical trade (in million tonnes) of total imports and exports of EU27 by product groups between 1999 and 2008.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: helmut.schuetz@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Eurostat, 2009; http://epp.eurostat.ec.europa.eu/portal/page/portal/external_trade/data/database" http://epp.eurostat.ec.europa.eu/portal/page/portal/external_trade/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''The data for imports and exports in physical units (originally 100 kg) by HS 2-digits product groups are taken from the Eurostat external trade data base.''',
      "Unit" : '''Imports and exports in million tonnes (Mt)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW111_Fig10_hsc.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW114_Fig3.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Total waste generation in the EU, EFTA, Turkey and Croatia in 2006 by source''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, total waste generation, mining and quarrying waste, construction and demolition waste, manufacturing waste excluding recycling, Waste from households, Other wastes''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the total waste generation distribution in percentages between different sources in the EU, EFTA, Croatia and Turkey in 2006''',
      "Themes" : '''Waste and material resources, Environmental technology''',
      "Geographical coverage" : '''EU-27, Croatia, Iceland, Norway, Switzerland, Turkey''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental Data Centre on Waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/waste/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''The category “Total other waste” was calculated by subtracting the categories, Total mining waste, Total construction and demolition waste, Total manufacturing waste and Total household waste from the category Total waste generation. The percentages in the figure were calculated by dividing the different categories with the category “Total waste generation”.''',
      "Unit" : '''Percent of total generation in 2006 (%)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW114_Total_waste_generation_by_source.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW115_Fig3.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Waste streams in the EU-27 and Norway by type of waste''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, waste streams, EU waste types, distribution of waste''',
      "Figure type" : '''Graph''',
      "Description" : '''The total generation of waste in the 27 EU member countries and Norway divided into 7 different categories. The figure shows that about two thirds of all waste in 2006 was mineral waste, mainly from mining, quarrying, construction and demolition.''',
      "Themes" : '''Waste and material resources, Household consumption''',
      "Geographical coverage" : '''EU27, Norway''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental Data centre on waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/statistics/search_database''',
      "Additional information" : '''''',
      "Methodology" : '''The EU-27 and Norway waste figures were added for each of the waste types. The ‘other waste’ fraction was calculated by subtracting all the waste types from the ‘Total wastes’. Finally the percentage was calculated on basis of the data for ‘Total waste’.''',
      "Unit" : '''Percent (%)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW115_Waste_streams_by_type.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW116_Fig3.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Trend in generation of municipal waste in the EU, EFTA countries, Turkey and Western Balkan countries, 2003 and 2008''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, waste generation, household waste, municipal waste, trend in generation of waste.''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure is a bar plot of the generation of municipal waste in kg per capita. The statistic covers 2003 and 2008.''',
      "Themes" : '''Waste and material resources, Household consumption''',
      "Geographical coverage" : '''Denmark, Ireland, Cyprus, Switzerland, Luxembourg, Malta, Netherlands, Austria, Spain, Germany, United Kingdom, Iceland, Italy, France, Sweden, Estonia, Finland, Belgium, Norway, Portugal, Bulgaria, Hungary, Greece, Slovenia, Turkey, Lithuania, Romania, Latvia, Poland, Slovakia, Czech Republic, Former Yugoslav Republic of Macedonia, Bosnia and Herzegovina, Albania, Serbia, Croatia''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2003,2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental Data centre on waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/waste/data/database''',
      "Additional information" : '''''',
      "Methodology" : '''The generation of municipal waste was plotted as raw data.''',
      "Unit" : '''Kg municipal waste generated per capita (kg/capita).'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW116_Municipal_waste_by_country_2003+2008_updated_WB+IT.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW120_Fig3.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Hazardous waste generation in the EU-15, EU-12 and in EU-27 plus Norway, Switzerland, and Croatia, 1997 to 2006''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, hazardous waste, waste generation''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure shows the amounts of hazardous waste generated in EU-15, EU-12 and EU-27 plus Norway, Switzerland, and Croatia in the years 1997 to 2006.''',
      "Themes" : '''Waste and material resources, Household consumption''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland, Italy, Latvia, Lithuania, Luxembourg, Malta, Netherlands, Norway, Poland, Portugal, Romania, Slovakia, Slovenia, Spain, Sweden, Switzerland, United Kingdom''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1997-2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Member States reporting to the EU Commission according to Council Regulation (EEC) No 259/93 of 1 February 1993''',
      "Additional information" : '''''',
      "Methodology" : '''The values for EU-15 were calculated by adding the values for Austria, Belgium, Denmark, Finland, France, Germany, Greece, Ireland, Italy, Luxembourg, Netherlands, Portugal, Spain, Sweden and United Kingdom. The values for EU-12 were calculated by adding the values for Bulgaria, Cyprus, Czech Republic, Estonia, Hungary, Latvia, Lithuania, Malta, Poland, Romania, Slovakia and Slovenia. The values for EU-27 + CH, HR, NO were calculated by adding the values for EU-15, EU-12, Norway, Switzerland, and Croatia.''',
      "Unit" : '''Million tonnes of hazardous waste.'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW120_Hazardous_waste_generation.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW123_Fig1.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Price developments for selected waste materials in the EU''',
      "Creators" : '''Christian Fischer and Anders Bjørn, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste,''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the development in unit price on a monthly basis of plastic, paper and glass waste from January 2000 to December 2009. The prices are calculated as weighted averages of a number of sub waste fractions for both export within and out of the EU.''',
      "Themes" : '''Waste and material resources, Industry, Transport''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2000-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''External trade database, Eurostat; 2010; http://appsso.eurostat.ec.europa.eu/nui/show.do?query=BOOKMARK_DS-016890_QID_60911498_UID_-3F171EB0&layout=PERIOD,L,X,0;REPORTER,L,Y,0;PARTNER,L,Z,0;PRODUCT,L,Z,1;FLOW,L,Z,2;INDICATORS,L,Z,3;&rankName1=REPORTER_1_2_0_1&rStp=&cStp=&rDCh=&cDCh=&rDM=true&cDM=true&codelab=L&wai=false&time_mode=FIXED&lang=en''',
      "Additional information" : '''''',
      "Methodology" : '''Initially the total quantities for each fraction were calculated by summing up all subcategories and multiplying with 10 to convert the unit from 100kg to tonne. Correspondingly the total values for each fraction were calculated by summing up all subcategories. Finally the unit prices have been calculated by dividing the total values with the total quantities for each of the three waste fractions.''',
      "Unit" : '''Price in Euro per tonne.'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW123_Price_development_for_selected_waste_materials.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW124_Fig3.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Biodegradable municipal waste landfilled in 2006 (% of biodegradable municipal waste generated in 1995), compared to targets of the European Landfill Directive''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows 2006 landfilling of biodegradable waste as a percentage of the 1995 biodegradable waste generation and how countries comply to the EU requirements for 2006, 2009 and 2016.''',
      "Themes" : '''Waste and material resources, Environmental technology''',
      "Geographical coverage" : '''Austria, Belgium, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland, Italy, Latvia, Lithuania, Luxembourg, Netherlands, Poland, Portugal, Romania, Slovenia, Spain, Sweden, United Kingdom''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1995,2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''European Comission, DG Environment and ECO Logic and Institute for European Environment Policy, 2009; http://ec.europa.eu/environment/waste/reporting/pdf/Landfil_Directive.pdf''',
      "Additional information" : '''''',
      "Methodology" : '''The percentage of biodegradable waste landfilled is calculated as percentage of biodegradable municipal waste generated in 1995 based on amounts of biodegradable municipal waste generated in 1995 and 1995, based on the data sources given below.''',
      "Unit" : '''Percent of 1995 generation (%)'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW124_Landfiling_biodegradable_municipal_waste.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW125_Map3.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Recycling rates for packaging waste in 2007 by country''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, packaging, wrapping,  recycling''',
      "Figure type" : '''Map''',
      "Description" : '''Generation and recycling of packaging waste in the member countries of the European Environment Agency. The data show that 18 countries in 2007 met the 2008 target of the Packaging Waste Directive (2004/12/EC) to recycle at least 55% of packaging waste generated, and one country missed the 2001 target to recycle at least 25%.''',
      "Themes" : '''Waste and material resources, Household consumption''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland, Italy, Latvia, Liechtenstein, Lithuania, Luxembourg, Malta, Netherlands, Norway, Poland, Portugal, Romania, Slovakia, Slovenia, Spain, Sweden, Switzerland, United Kingdom''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2006,2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental Data centre on waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/waste/data/wastestreams/packaging_waste''',
      "Additional information" : '''2007 (for Malta 2006)''',
      "Methodology" : '''The recycling rate was calculated using data on the absolute amounts of packaging waste generated and recycled reported by the respective countries''',
      "Unit" : '''Percent (%)'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW126_Fig3.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''WEEE put on the market, collected and recycled/recovered/reused in 23 European countries (kg/person), all figures relate to 2006''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure shows the amount of Waste Electrical and Electronic Equipment (WEEE) that has been put on the market, collected in total, collected from private households and reused and recycled in 22 European countries, stated in kg/capita. The figures are related to the collection target of 4kg/capita/year. All values are related to 2006.''',
      "Themes" : '''Waste and material resources, Household consumption''',
      "Geographical coverage" : '''Norway, Denmark, Finland, Sweden, Belgium, France, Poland, Germany, Cyprus, Austria, Luxembourg, Greece, Lithuania, Estonia, Slovenia, Hungary, Spain, Portugal, Netherlands, Slovakia, Romania, Italy, Switzerland''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2006''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental data centre on waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/waste/data/wastestreams/weee''',
      "Additional information" : '''''',
      "Methodology" : '''In order to calculate the per capita value for the four data types each data type was divided by the numbers of inhabitants for each country and multiplied with 1000 to convert tonnes into kg.''',
      "Unit" : '''WEEE in kg/capita/year'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW126_WEEE_updated.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW127_Fig3.7.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Shipments of notified waste from EU Member States to other EU and non-EU countries, 1997–2005''',
      "Creators" : '''Christian Fischer and Claus Davidsen, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste''',
      "Figure type" : '''Graph''',
      "Description" : '''The figure illustrates the amount of transboundary shipped notified waste, in Million tonnes, traded from EU-member states to different countries. These cover countries within EU-15, EFTA, Non-OECD (inkl. BG and RO), EU-12 excl. BG + RO and OECD (non-EFTA).''',
      "Themes" : '''Waste and material resources, Transport''',
      "Geographical coverage" : '''EU15, EU12, EFTA''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1997-2005''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA (European Environmental Agency), 2009; http://www.eea.europa.eu/''',
      "Additional information" : '''EU-15, EFTA, Non-OECD (inkl. BG and RO), EU-12 excl. BG + RO and OECD (non-EFTA).''',
      "Methodology" : '''All data in the figure was given directly by the source and no methodology has therefore been used to transform them.''',
      "Unit" : '''Million tonnes of transboundary shipped notified waste'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW127_Transboundary_shipments_of_waste.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW128_Fig3.8.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Emissions from municipal waste management in the EU-27, excluding Cyprus, plus Norway and Switzerland, 1990 and 2008, CO2-equivalents''',
      "Creators" : '''Ioannis Bakas, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the net emissions of greenhouse gases from the waste management sector in EU-27 (minus Cyprus), Norway and Switzerland. The figure also shows the emissions associated with each waste management option.''',
      "Themes" : '''Waste and material resources, Environmental technology''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland,Italy, Latvia, Lithuania, Luxembourg, Malta, Netherlands, Poland, Portugal, Romania, Slovakia, Slovenia,Spain, Sweden, United Kingdom, Norway, Switzerland''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1995,2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: bakasi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''European Topic Centre on Sustainable Consumption and Production, 2010; not yet available. See 2010 ETC/SCP paper "Projections of municipal solid waste management and greenhouse gas emissions"''',
      "Additional information" : '''''',
      "Methodology" : '''The calculations behind the derived data are presented in the 2010 ETC/SCP paper "Projections of municipal solid waste management and greenhouse gas emissions".''',
      "Unit" : '''Million tonnes CO2-eq.'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW128_GHG_Emissions_of_MSW_management_by_treatment_path.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW129_Fig3.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Trends and outlook for management of municipal waste in the EU-27 (excluding Cyprus) plus Norway and Switzerland, baseline scenario''',
      "Creators" : '''Ioannis Bakas, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the waste generation in the EU-27 (without Cyprus) plus Norway and Switzerland and the distribution between treatment paths from 1990 to 2020.''',
      "Themes" : '''Waste and material resources, Environmental technology''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland,Italy, Latvia, Lithuania, Luxembourg, Malta, Netherlands, Poland, Portugal, Romania, Slovakia, Slovenia,Spain, Sweden, United Kingdom, Norway, Switzerland''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2020''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: chrfi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Environmental Data Centre on Waste, Eurostat, 2010; http://epp.eurostat.ec.europa.eu/portal/page/portal/waste/data''',
      "Additional information" : '''''',
      "Methodology" : '''The waste generation and distribution between treatment options for 1990-1994 has been backcasted by ETC/SCP’s best estimate. The data for 1995-2008 are based on reported data. The waste generation for 2009-2020 has been forecasted using historical trends, correlations between population, economic development and waste generation, and population and economic projections of the European Commission. The corresponding distribution between treatment options has been forecasted using ETC/SCP’s best estimate. This methodology is presented in the 2010 ETC/SCP paper "Projections of municipal solid waste management and greenhouse gas emissions" (forthcoming).''',
      "Unit" : '''Million tonnes of MSW'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW129_Trend_and_outlook_MSW_EU27+NO+CH.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW130_Fig3.10.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''GHG emissions avoided due to better management of municipal waste in the EU-27 plus Norway and Switzerland''',
      "Creators" : '''Ioannis Bakas, Copenhagen Resource Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, greenhouse gases''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows avoided net emissions of greenhouse gases from the waste management sector in EU-27 (minus Cyprus), Norway and Switzerland. More detailed, the figure shows the difference in the net emissions in years 2008 and 2020 scenarios to the base year’s (1995) net emissions''',
      "Themes" : '''Waste and material resources, Environmental technology''',
      "Geographical coverage" : '''Austria, Belgium, Bulgaria, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Ireland,Italy, Latvia, Lithuania, Luxembourg, Malta, Netherlands, Poland, Portugal, Romania, Slovakia, Slovenia,Spain, Sweden, United Kingdom, Norway, Switzerland''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.cri.dk, Copenhagen Resource Institute''',
      "Processor" : '''''',
      "Temporal coverage" : '''2020,2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Almut Reichel; Almut.Reichel@eea.europa.eu
Outside contact: bakasi@etc.mim.dk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''European Topic Centre on Sustainable Consumption and Production, 2010; Not yet available. See 2010 ETC/SCP paper "Projections of municipal solid waste management and greenhouse gas emissions"''',
      "Additional information" : '''''',
      "Methodology" : '''The calculations behind the derived data are presented in the 2010 ETC/SCP paper "Projections of municipal solid waste management and greenhouse gas emissions".''',
      "Unit" : '''Million tonnes CO2-eq.'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/RW130_Net_GHG_emissions_municipal_waste_scenarios.xls''',
      "Category" : '''Hard copy''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/RW131_Fig4.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Long-term trends in material productivity 1980 (1992)–2007''',
      "Creators" : '''Sören Steger, Wuppertal Institute''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, material resources, waste, material productivity''',
      "Figure type" : '''Graph''',
      "Description" : '''This figure shows the material productivity (GDP per tonnes DMC) for selected EU member countries and selected non-EU countries between 1980 or 1992 (EU 12 countries and Norway), respectively, and 2007, or 2005, respectively.''',
      "Themes" : '''Waste and material resources''',
      "Geographical coverage" : '''EU15, EU12''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-25''',
      "Owner" : '''http://www.wupperinst.org/en/home/index.html, Wuppertal Institute''',
      "Processor" : '''http://www.wupperinst.org/en/home/index.html''',
      "Temporal coverage" : '''1980-2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Pawel Kazmierczyk; Pawel.Kazmierczyk@eea.europa.eu
Outside contact: soeren.steger@wupperinst.org
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''The Conference Board: The Total Economy Database, Output, Labor and Labor Productivity Country Details, 1950-2009, January 2010 Release, 2010; http://www.conference-board.org/economics/database.cfm''',
      "Additional information" : '''''',
      "Methodology" : '''The data are taken from external data bases (GDP from The Conference Board – Total Economy Database, DMC from IFF database, WI database, Eurostat, and OECD).''',
      "Unit" : '''GDP in 1990 US$ (converted at Geary Khamis PPPs) per ton DMC'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS102_Fig2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Observed global fossil fuel CO2 emissions compared with six scenarios from the IPCC''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, emissions, CO2''',
      "Figure type" : '''Graph''',
      "Description" : '''IPCC scenarios shown are from the IPCC Special Report on Emissions Scenarios (IPCC, 2000). Past emission data are from the Carbon Dioxide Information and Analysis Center (CDIAC) and the International Energy Agency (IEA)''',
      "Themes" : '''Climate change, Transport''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.ipcc.ch/index.htm''',
      "Processor" : '''''',
      "Temporal coverage" : '''1980-2010''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Global Carbon Project, 2009''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS104_ID1105_Fig2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Observed and projected global mean surface temperatures from 1900, for three IPCC scenarios and the 'Year 2000 constant concentration' pathway''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, surface temperature''',
      "Figure type" : '''Graph''',
      "Description" : '''If global greenhouse gas emissions would not be reduced, the 2°C target will be exceeded towards the middle of the 21st century. The horizontal 2°C target line takes into account warming of about 0.6 °C from pre-industrial to 1990. “Likely” ranges in average 2090-2099 warming for all six IPCC scenarios are shown on the right''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.ipcc.ch/index.htm''',
      "Processor" : '''''',
      "Temporal coverage" : '''1900-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''IPCC, 2010''',
      "Additional information" : '''The figure is covering EU and the rest of the world. Temporal coverage for the projections: 1900 - 2100''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS105_Fig2.8.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Observed and projected change in sea level 1970–2008, relative to the sea level in 1990''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, sea-level change''',
      "Figure type" : '''Graph''',
      "Description" : '''The solid lines are based on observations smoothed to remove the effects of interannual variability (light lines connect data points). Data in most recent years are obtained via satellite based sensors. The envelope of IPCC (2001) projections is shown for comparison; this includes the broken lines as individual projections and the shading as the uncertainty around the projections.''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pik-potsdam.de/, Potsdam Institute for Climate Impact Research (PIK)''',
      "Processor" : '''''',
      "Temporal coverage" : '''1970-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Stefan Rahmstorf; rahmstorf@ozean-klima.de
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Potsdam Institute for Climate Impact Research 2010''',
      "Additional information" : '''The figure is covering EU and the rest of the world. 1970 – 2100 (projections)''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS106_Fig2.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Projected global average sea-level rise, 1990–2100''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, sea-level rise''',
      "Figure type" : '''Graph''',
      "Description" : '''Past observed and projected sea level rise from various information sources''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pik-potsdam.de/, Potsdam Institute for Climate Impact Research (PIK)''',
      "Processor" : '''''',
      "Temporal coverage" : '''1990-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Stefan Rahmstorf; rahmstorf@ozean-klima.de
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Sea-level rise, IPCC - www.ipcc.int, 2007
Sea-level rise, PIK - www.ozean-klima.de, (Ramstdorf et al), 2007
Sea-level rise, Goddard Institute for Space Studies, 2008
Sea-level rise, DMI - www.dmi.dk, Grinsted et al (Danish Met. Institute), 2009
Sea-level rise, Vermeer and Rahmstorf - www.ozean-klima.de, 2009
Sea-level rise, Jevrejeva et al., 2010''',
      "Additional information" : '''The figure is covering EU and the rest of the world. 1990 – 2100 (projections)''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS107_Map2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Arctic summer sea-ice age 1981–2000 compared with 2007, 2008, and 2009''',
      "Creators" : '''Blaz Kurnik''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, arctic sea ice''',
      "Figure type" : '''Map''',
      "Description" : '''These images compare ice age, a proxy for ice thickness, in 2007, 2008, 2009, and the 1981–2000 average. 2009 saw an increase in second-year ice over 2008. At the end of summer 2009, 32% of the ice cover was second-year ice and three-year and older ice were 19% of the total ice cover, the lowest in the satellite record.''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''Norway''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.npolar.no, Center for Ice Climate and Ecosystems (ICE)''',
      "Processor" : '''''',
      "Temporal coverage" : '''1980-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Percent of total amount of ice 1981 - 2009, National Snow and Ice Data Center - http://nsidc.org, 2010''',
      "Additional information" : '''The geographical coverage is Polar and Arctic areas''',
      "Methodology" : '''Satellite measurements. Platform: DMSP > Defense Meteorological Satellite Program, NIMBUS-7 Instruments: SSMI/S > Special Sensor Microwave Imager/Sounder and SMMR > Scanning Multichannel Microwave Radiometer''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS108_Fig2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Observed and projected Arctic September sea-ice extent, 1900–2100''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, sea-ice extent''',
      "Figure type" : '''Graph''',
      "Description" : '''''',
      "Themes" : '''Climate Change''',
      "Geographical coverage" : '''Norway''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://nsidc.org, National Snow and Ice Data Center''',
      "Processor" : '''''',
      "Temporal coverage" : '''1900-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: J. Stroeve; stroeve@kryos.colorado.edu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''National Snow and Ice Data Centre (NSIDC)''',
      "Additional information" : '''The geographical coverage is Polar and Arctic areas, 1990 – 2100 (projections),  September Ice extent''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS109_Fig2.7.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Melting area 1979–2008 and mass change 2003–2009 of the Greenland ice sheet''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change''',
      "Figure type" : '''Graph''',
      "Description" : '''The area of the Greenland ice sheet where there is at least one day of surface melting in summer increased to a new record extent in 2007.''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''Greenland''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://cires.colorado.edu''',
      "Processor" : '''''',
      "Temporal coverage" : '''1978-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Konrad Steffen; Konrad.steffen@colorado.edu
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Satellite passive microwave data, National Snow and Ice Data Center, Boulder, Colorado 2007, http://nsidc.org/''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS110_ID1110_Map3.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Potential climatic tipping elements''',
      "Creators" : '''Blaz Kurnik''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change''',
      "Figure type" : '''Map''',
      "Description" : '''Tipping elements are regional-scale features of the climate that could exhibit threshold-type behaviour in response to human-driven climate change – that is, a small amount of climate change at a critical point could trigger an abrupt and/or irreversible shift in the tipping element. The consequences of such shifts for societies and ecosystems are likely to be severe. Question marks indicate systems whose status as tipping elements is particularly uncertain. There are other potential tipping elements that are missing from the map, for example shallow-water coral reefs (Veron et al. 2009) threatened in part by ocean acidification''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pik-potsdam.de/, Potsdam Institute for Climate Impact Research (PIK)''',
      "Processor" : '''''',
      "Temporal coverage" : '''2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Susanne Zirkel; Susanne.Zirkel@pik-potsdam.de
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Potsdam Institute for Climate Impact Research (PIK)''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS111_TippingElementsAndEurope_black_txt_Map3.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Potential tipping elements with direct impacts on Europe''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, tipping elements''',
      "Figure type" : '''Map''',
      "Description" : '''Colours show population density''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pik-potsdam.de/, Potsdam Institute for Climate Impact Research (PIK)''',
      "Processor" : '''''',
      "Temporal coverage" : '''2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Anders Levermann; anders.levermann@pik-potsdam.de
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''EEA 2010''',
      "Additional information" : '''The figure is covering EU and the rest of the world''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS112_Fig3.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Ocean acidity over the past 25 million years and projected to 2100''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, ocean acidity''',
      "Figure type" : '''Graph''',
      "Description" : '''''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pml.ac.uk, Plymouth Marine Laboratory''',
      "Processor" : '''''',
      "Temporal coverage" : '''2010''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: C. Turley; CT@pml.ac.uk
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Ocean acidity over the past 25 M years and projected to 2100, Plymouth Marine Laboratory - www.pml.ac.uk, 2009''',
      "Additional information" : '''The figure is covering EU and the rest of the world. The temporal coverage is: -25 M years – 2100 (projections)''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS113_Fig3.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''The probability of exceeding 2 °C global warming versus CO2 emitted from 2000–2049''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, CO2, impacts''',
      "Figure type" : '''Graph''',
      "Description" : '''Text bellow the image''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.pik-potsdam.de/, Potsdam Institute for Climate Impact Research (PIK)''',
      "Processor" : '''''',
      "Temporal coverage" : '''2000-2050''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Malte Meinshausen, malte.meinshausen@pik-potsdam.de
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''Meinshausen et al., 2009.''',
      "Additional information" : '''The figure is covering EU and the rest of the world, the projections: 2000-2050''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS117-CCS118_Map2.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Projected changes in annual and summer precipitation between 1961–1990 and 2071–2100''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, scenarios, precipitation changes''',
      "Figure type" : '''Map''',
      "Description" : '''Annual changes in % as simulated by ENSEMBLES Regional Climate Models for the IPCC SRES A1B emission scenario.''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.ensembles-eu.metoffice.com, ENSEMBLE FP6 project''',
      "Processor" : '''''',
      "Temporal coverage" : '''1961-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact:
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''DM Iensembles-eu.metoffice.com, www.nature.com''',
      "Additional information" : '''''',
      "Methodology" : '''Raster data in AAIGRID format''',
      "Unit" : '''%'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCS121_Fig2.10.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Cumulative specific net mass balance of selected glaciers from European glaciated regions, 1946–2008''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, understanding climate change, glaciers, Impacts''',
      "Figure type" : '''Graph''',
      "Description" : '''''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''2010-11-29''',
      "Owner" : '''http://www.geo.unizh.ch/wgms''',
      "Processor" : '''''',
      "Temporal coverage" : '''1946-2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Blaz Kurnik; Blaz.Kurnik@eea.europa.eu
Outside contact: Michael Zemp; michael.zemp@geo.uzh.ch
Operator: Carsten Iversen; Carsten.Iversen@eea.europa.eu''',
      "Source" : '''World Glacier Monitoring Service, 2010''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI128_Map2.8.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Modelled change of the flowering date for winter planted wheat, 1975–2007''',
      "Creators" : '''Stéphane Isoard''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, agriculture, phenology''',
      "Figure type" : '''Map''',
      "Description" : '''Changes of the flowering date for winter planted wheat between 1975 and 2007''',
      "Themes" : '''Climate change, Agriculture, Biodiversity''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1975–2007''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact:
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''European Environment Agency, 2008
www.eea.europa.eu''',
      "Additional information" : '''EEA member countries''',
      "Methodology" : '''The day of the year of flowering has been simulated using a crop growth model (Crop Growth Monitoring System (CGMS)).''',
      "Unit" : '''Days/year'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI130_Map2.9.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Modelled conditions for summer tourism in Europe for 1961–1990 and 2071–2100''',
      "Creators" : '''Juan Carlos Ciscar (IPTS)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, tourism''',
      "Figure type" : '''Map''',
      "Description" : '''Conditions for summer tourism in Europe for 1961–1990 and 2071–2100''',
      "Themes" : '''Climate change, Tourism''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1961-1990, 2071-2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Juan Carlos Ciscar (IPTS); Juan-Carlos.Ciscar@ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2009
http://ipts.jrc.ec.europa.eu/''',
      "Additional information" : '''EEA member countries''',
      "Methodology" : '''Simulated conditions for summer tourism in Europe for 1961–1990 and 2071–2100 according to a high-emissions scenario (IPCC SRES A2). More information is available in Ciscar et al., 2009 and Amelung and Moreno, 2009.''',
      "Unit" : '''Tourism comfort index (TCI)'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI131_Fig2.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Natural disasters in EEA member countries, 1980–2009''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, natural disasters, hazards, risks''',
      "Figure type" : '''Graph''',
      "Description" : '''Natural disasters in EEA member countries from 1980 to 2009''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.munichre.com''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1980-2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Petra Löw; ploew@munichre.com; Angelika Wirtz; awirtz@munichre.com
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''Munich Reinsurance Company, 2010
NatCatSERVICE
www.munichre.com''',
      "Additional information" : '''EEA member countries''',
      "Methodology" : '''Definition loss events: Events can occur in several countries; events are counted countrywise.''',
      "Unit" : '''Number of events; fatalities, EUR billions, %'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI133_Fig2.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Normalised windstorm losses in Europe from major windstorm disasters''',
      "Creators" : '''José Barredo (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, windstorms''',
      "Figure type" : '''Graph''',
      "Description" : '''Losses from major windstorm disasters in Europe between 1970 and 2008''',
      "Themes" : '''Climate change, Water, Coasts and seas''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1970 - 2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: José Barredo (IES); jose.barredo@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2010
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states''',
      "Methodology" : '''The methodology is described in details in Barredo (JRC), 2010.''',
      "Unit" : '''Million EUR of 2008 in PPP'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI135_Map2.7.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''People expected to be at risk of flooding without adaptation in the medium-long term''',
      "Creators" : '''Jochen Hinkel''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, coasts''',
      "Figure type" : '''Map''',
      "Description" : '''People expected to be at risk of flooding without adaptation in the medium-long term''',
      "Themes" : '''Climate change, Water, Coasts and seas''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2050,2100''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Jochen Hinkel; hinkel@pik-potsdam.de
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''PIK (Potsdam Institute for Climate Impact Research), 2010''',
      "Additional information" : '''EU member states''',
      "Methodology" : '''Based on the DIVA model. More information is available in Hinkel et al., 2010; 2009.''',
      "Unit" : '''Thousands per year'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI135_Map2-7_SOER2010_Adapting_CC.zip''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI136_Map2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Coastal flood damage potential''',
      "Creators" : '''José Barredo (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, coasts''',
      "Figure type" : '''Map''',
      "Description" : '''Damage potential of coastal flooding in Europe''',
      "Themes" : '''Climate change, Water, Coasts and seas''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2010''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: José Barredo; jose.barredo@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2009
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states, no specific dates given''',
      "Methodology" : '''This map presents coastal flood damage potential for a 100-year return period storm-surge, current climate and no defences. More information is available in Barredo, Salamon and Feyen (JRC), 2009.''',
      "Unit" : '''Million euro in purchasing power parities (PPP)'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI138_Map2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Major flood disasters in the EU, Switzerland and Norway, 1950–2009''',
      "Creators" : '''José Barredo (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, water''',
      "Figure type" : '''Map''',
      "Description" : '''Major flood disasters according to flood types and spatial relevance''',
      "Themes" : '''Climate change, Water, Coasts and seas''',
      "Geographical coverage" : '''EU27, Switzerland, Norway''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1950–2009''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: José Barredo; jose.barredo@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2010
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU, Switzerland and Norway''',
      "Methodology" : '''This map is based on data from Em-dat, Munich Re and Dartmouth Flood Observatory.''',
      "Unit" : '''Individual events'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI139_Fig2.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Normalised flood losses in Europe from major disasters''',
      "Creators" : '''José Barredo (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, water''',
      "Figure type" : '''Graph''',
      "Description" : '''Losses from major flood disasters in Europe between 1970 and 2008''',
      "Themes" : '''Climate change, Water''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1970 - 2008''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: José Barredo; jose.barredo@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2010
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states''',
      "Methodology" : '''The methodology is described in details in Barredo (JRC), 2009.''',
      "Unit" : '''Million EUR of 2008 in PPP'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI141_Map2.2.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Riverine flood damage potential''',
      "Creators" : '''José Barredo (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, water''',
      "Figure type" : '''Map''',
      "Description" : '''Damage potential of riverine floods in Europe''',
      "Themes" : '''Climate change, Water''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2010''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: José Barredo; jose.barredo@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2010
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states, no specific dates given''',
      "Methodology" : '''This map presents riverine flood damage potential for a 100-year return period, current climate and no defences; catchments and sub-catchments of less than 500 km2 are not included. More information is available in Barredo, Salamon, Feyen, Dankers, Bódis and De Roo (JRC), 2008.''',
      "Unit" : '''Million euro in purchasing power parities (PPP)'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI142_Map2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Expected impact of climate change on future flood damage''',
      "Creators" : '''Luc Feyen (IES)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, floods, water''',
      "Figure type" : '''Map''',
      "Description" : '''Expected impact of climate change on future flood damage''',
      "Themes" : '''Climate change, Water''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2071–2100, 1961–1990''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Luc Feyen (IES); luc.feyen@jrc.ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2010
http://ies.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states,scenario (2071–2100) relative to control period (1961–1990)''',
      "Methodology" : '''This map presents the relative change in expected annual damage (EAD) between scenario (2071–2100) and control period (1961–1990) (%). More information is available in Feyen et al., 2010.''',
      "Unit" : '''%'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI144_Map2.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Water limitation of crop primary production in Europe under rain-fed conditions''',
      "Creators" : '''Dieter Gerten''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, agriculture, water''',
      "Figure type" : '''Map''',
      "Description" : '''Present and projected water limitation of crop primary production in Europe under rain-fed conditions''',
      "Themes" : '''Climate change, Agriculture, Water''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1971–2000, 2070–2099''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Dieter Gerten; gerten@pik-potsdam.de
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''PIK (Potsdam Institute for Climate Impact Research), 2009''',
      "Additional information" : '''EEA member countries, present (1971–2000) and projected (2070–2099)''',
      "Methodology" : '''This map shows the crop water limitation index expressed as the ratio between actual and theoretical (unlimited water) production averaged over all crop types — and its projected changes under IPCC B1 and A2 climate and emissions scenarios in absolute change in the crop water limitation index. The values represent the average over the growing period for all crop types present in a grid cell. Note that no adaptation is assumed and that in regions that are irrigated today (not considered here) the ratio is likely to be close to 1. Based on the LPJmL (Lund-Potsdam-Jena managed Land Dynamic Global Vegetation and Water Balance Model) vegetation and water balance model using the ensemble mean from 21 General Circulation Models (GCMs) that took part in the 4th IPCC Assessment (Randall et al., 2007). More information is available in Gerten, 2009.''',
      "Unit" : '''Water limitation index / Change of water limitation'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI144_map2-4_SOER2010_AdaptingCC.zip''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI145_Map2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Annual water availability per person (Falkenmark indicator)''',
      "Creators" : '''Dieter Gerten''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, water''',
      "Figure type" : '''Map''',
      "Description" : '''Present and projected annual water availability per person''',
      "Themes" : '''Climate change, Water''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1971–2000, 2070–2099''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Dieter Gerten; gerten@pik-potsdam.de
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''PIK (Potsdam Institute for Climate Impact Research), 2009''',
      "Additional information" : '''EEA member countries, present (1971–2000) and projected (2070–2099)''',
      "Methodology" : '''Values less than 1 700 m3 per person per year indicate water shortage. Based on the LPJmL vegetation and water balance model using the ensemble mean from 21 General Circulation Models (GCMs) that took part in the 4th IPCC Assessment (Randall et al., 2007). More information is available in Gerten, 2009.''',
      "Unit" : '''m3/cap/year'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI145_map2-5_SOER2010_AdatingCC.zip''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI148_Map2.10.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Suitability of the establishment of the tiger mosquito under the minimum climate change scenario, long term (2030)''',
      "Creators" : '''Els Ducheyne (Avia-GIS)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, human health''',
      "Figure type" : '''Map''',
      "Description" : '''Projected suitability of the establishment of the tiger mosquito''',
      "Themes" : '''Climate change, Environment and health''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://ecdc.europa.eu/en''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2030''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Jan Semenza (ECDC); Jan.Semenza@ecdc.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''European Centre for Disease Prevention and Control (ECDC), 2009
http://www.ecdc.europa.eu/''',
      "Additional information" : '''EEA member countries''',
      "Methodology" : '''Adapted from 'Prospective impact of climate change on Aedes albopictus distribution in Europe: minimal impact, long-term change scenario' in ECDC Technical Report 'Development of Aedes albopictus risk maps'. European Centre for Disease Prevention and Control (ECDC), 2009.''',
      "Unit" : '''Suitability levels'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI150_Map3.1.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Potential increase in crop production under the adaptation scenario''',
      "Creators" : '''Dieter Gerten''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, agriculture, water''',
      "Figure type" : '''Map''',
      "Description" : '''Potential increase in crop production under an adaptation scenario''',
      "Themes" : '''Climate change, Agriculture, Water''',
      "Geographical coverage" : '''EEA32''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''1971–2000''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Dieter Gerten; gerten@pik-potsdam.de
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''PIK (Potsdam Institute for Climate Impact Research), 2009''',
      "Additional information" : '''EEA member countries, recent climatic conditions (1971–2000) and distribution of cropland and crop types as of 2000.''',
      "Methodology" : '''25 % of runoff from cropland collected and used during dry-spells (water harvesting) and 25 % of soil evaporation from cropland avoided to increase plant transpiration (vapour shift). Simulation done for recent climatic conditions (1971–2000 average) and distribution of cropland and crop types as of 2000. Based on the LPJmL vegetation and water balance model using the ensemble mean from 21 General Circulation Models (GCMs) that were part of the 4th IPCC Assessment (Randall et al., 2007). More information is available in Gerten, 2009.''',
      "Unit" : '''%'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI150_map3-1_SOER2010_AdaptingCC.zip''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI151_Fig3.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Comparison of the average annual costs of adaptation in developing countries''',
      "Creators" : '''Alistair Hunt (Metroeconomica) / Paul Watkiss (Paul Watkiss Associates)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, costs of adaptation, developing countries''',
      "Figure type" : '''Graph''',
      "Description" : '''Comparison of the average annual costs of adaptation in developing countries''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2010-2050, 2030''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Alistair Hunt (Metroeconomica); ecsasph@bath.ac.uk and Paul Watkiss (Paul Watkiss Associates); paul_watkiss@btinternet.com
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''Metroeconomica / Paul Watkiss Associates, 2010''',
      "Additional information" : '''Developing countries''',
      "Methodology" : '''More information available in UNFCCC (2009), based on UNFCCC (2007) and World''',
      "Unit" : '''USD billion/year'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI151_Figure 3.3.xls''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI152_Fig3.4.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Comparison of the average annual costs of adaptation in developed countries''',
      "Creators" : '''Alistair Hunt (Metroeconomica) / Paul Watkiss (Paul Watkiss Associates)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, costs of adaptation, developed countries''',
      "Figure type" : '''Graph''',
      "Description" : '''Comparison of the average annual costs of adaptation in developed countries''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2030''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Alistair Hunt (Metroeconomica); ecsasph@bath.ac.uk and Paul Watkiss (Paul Watkiss Associates); paul_watkiss@btinternet.com
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''Metroeconomica / Paul Watkiss Associates, 2010''',
      "Additional information" : '''Developed countries''',
      "Methodology" : '''Compiled based on UNFCCC (2007) and Stern (2006).''',
      "Unit" : '''USD billion/year'''
    },
    {
      "Object type" : '''EEAFigureFile''',
      "Filepath" : '''FINAL_FIGUREFILES/CCI152_Figure 3.4.xls''',
      "Category" : '''''',
      "Title" : '''''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''''',
      "Figure type" : '''''',
      "Description" : '''''',
      "Themes" : '''''',
      "Geographical coverage" : '''''',
      "EEA Management Plan" : '''''',
      "Last upload" : '''''',
      "Owner" : '''''',
      "Processor" : '''''',
      "Temporal coverage" : '''''',
      "Contact person(s) for EEA" : '''''',
      "Source" : '''''',
      "Additional information" : '''''',
      "Methodology" : '''''',
      "Unit" : ''''''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI156_Fig2.3.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Occurrence of assessed butterfly and amphibian species of different vulnerability categories in bio-geographical regions, 2050, A2 scenario''',
      "Creators" : '''''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, biodiversity, species, bio-geographical regions''',
      "Figure type" : '''Graph''',
      "Description" : '''Vulnerability of assessed butterfly and amphibian species of different vulnerability categories in bio-geographical regions''',
      "Themes" : '''Climate change, Biodiversity''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://www.eea.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2050''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Monika Bertzky; Monika.Bertzky@unep-wcmc.org
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''UNEP (United Nations Environment Programme) – WCMC (World Conservation Monitoring Centre), 2009''',
      "Additional information" : '''EU member states''',
      "Methodology" : '''The methodology is described in Bertzky et al., 2009.''',
      "Unit" : '''Number of species'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI158_Fig2.6.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Sectoral decomposition of regional welfare changes''',
      "Creators" : '''Juan Carlos Ciscar (IPTS)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, welfare change''',
      "Figure type" : '''Graph''',
      "Description" : '''Sectoral decomposition of regional welfare changes due to climate change''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2010,2080''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Juan Carlos Ciscar (IPTS); Juan-Carlos.Ciscar@ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2009
http://ipts.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states, present economic situation. 2080s climate conditions.''',
      "Methodology" : '''The methodology is described in details in Ciscar et al., 2009.''',
      "Unit" : '''%'''
    },
    {
      "Object type" : '''EEAFigure''',
      "Filepath" : '''FINAL_FIGURES/CCI159_Fig2.5.eps''',
      "Category" : '''Hard copy''',
      "Title" : '''Annual damage in terms of GDP loss (million EUR) and welfare change (%)''',
      "Creators" : '''Juan Carlos Ciscar (IPTS)''',
      "Contributors" : '''''',
      "Copyrights" : '''''',
      "Keywords" : '''SOER2010, thematic assessment, climate change, adaptation, economic damage costs, welfare change''',
      "Figure type" : '''Graph''',
      "Description" : '''Annual damage and welfare change due to climate change''',
      "Themes" : '''Climate change''',
      "Geographical coverage" : '''EU27''',
      "EEA Management Plan" : '''2010''',
      "Last upload" : '''2010-12-03''',
      "Owner" : '''http://agrienv.jrc.ec.europa.eu''',
      "Processor" : '''Carsten Iversen; carsten.iversen@eea.europa.eu''',
      "Temporal coverage" : '''2010,2080''',
      "Contact person(s) for EEA" : '''Inhouse contact: Stéphane Isoard; stephane.isoard@eea.europa.eu
Outside contact: Juan Carlos Ciscar (IPTS); Juan-Carlos.Ciscar@ec.europa.eu
Operator: Anne Louise Skov; anne.skov@eea.europa.eu''',
      "Source" : '''EC JRC, 2009
http://ipts.jrc.ec.europa.eu/''',
      "Additional information" : '''EU member states, present economic situation. 2080s climate conditions.''',
      "Methodology" : '''The methodology is described in details in Ciscar et al., 2009.''',
      "Unit" : '''Million EUR and %'''
    }
  ]
}